import java.util.Random;

public abstract class Player {
    protected boolean myTurn;
    protected boolean isServer;
    protected boolean waitingForResponse;
    protected Player enemy;
    protected String name;
    protected Board board;
    protected boolean myCoin;

    protected boolean sendCoin;

    protected boolean haseReceivedCoin;

    public Player() {
        this.haseReceivedCoin = false;
        this.sendCoin = false;
    }

    public void createBoard(int size) {
        this.board = new Board(size);
    }

    public abstract void receiveShoot(Point point);

    public abstract void receiveHit(HitResponse hitResponse);

    public abstract void shoot(Point point);

    public void beginTrun() {

    }

    public void setEnemy(Player enemy) {
        this.enemy = enemy;
    }

    public void setName(String name) {
        this.name = name;
    }
    public String getName() {
        return this.name;
    }

    public Board getBoard() {
        return this.board;
    }

    public abstract void receiveCoin(boolean coin);
}
